function uh = scara2idf(xx,parm)

% QRxSCARA{bg̋t͊w
%     xx   : [q1;q2;q1';q2';qr1';qr2';q1";q2"];
%     parm : [M12; m11; m22; D1; D2; g1; g2]

Y = zeros(2,7);
c2 = cos(xx(2)); s2 = sin(xx(2));
Y(1,1) = c2*(2*xx(7)+xx(8)) - s2*(xx(4)*xx(5)+(xx(3)+xx(4))*xx(6));
Y(1,2) = xx(7);
Y(1,3) = xx(8);
Y(1,4) = xx(3);
Y(2,1) = c2*xx(7) + s2*xx(3)*xx(5);
Y(2,3) = xx(7)+xx(8);
Y(2,5) = xx(4);
c1 = cos(xx(1)); c12 = cos(xx(1)+xx(2));
Y(1,6) = c1;
Y(1,7) = c12;
Y(2,7) = c12;

uh = Y*parm;
