function [g1a,g2a,g1b,g2b] = wm_scidens1(u1,u2,q11,q21,q12,q22,q13,q23)

% Working Model 2Dō쐬2DOF SCARA Robot̓i肻1j
%   g1a    : QŒŐÎ~ł̃p[^g1̐l
%   g2a    : PŒŐÎ~ł̃p[^g2̐l
%   g1b,g2b: Î~ł̃p[^g1g2̐l
%   u1, u2 : ̓gN
%   q11,q21: PŒŐÎ~ł̊֐ߊp
%   q12,q22: QŒŐÎ~ł̊֐ߊp
%   q13,q23: Î~ł̊֐ߊp
%
%-----------------------------------------------------------
%
% 0. 
%   (1) Working Model 2DŊpxƓ͂ł悤ɁCMeasureǉD
%   (2) MeasurePropertiesLabelEquationォ珇Ɏ̂悤ɐݒ肷D
%        () Label  Equation
%              t     time
%              a1    Body[1].a.r
%              a2    Body[2].a.r-Body[1].a.r
%              u1    Input[12]
%              u2    Input[16]
%        CLabel͔Cӂ̖Oł悢C
%                BodyInput̔ԍ͎̃fɍ킹邱ƁD
%
% 1. FÎ~
%  1.1 PŒŐÎ~
%   (1) Application InterfacêQInput (u1u2)DisconnectɂD
%   (2) PNAnchorłD
%   (3) QInputiu2j̃XC_[Kȑ傫ɐݒ肵CV~[VC
%      XԂŐÎ~D
%   (4) Î~̊֐ߊpq11,q21Ɠu2̒l
%		g2a=u2/cos(q11+q21);
%
%  1.2 QŒŐÎ~
%   (1) PNAnchor폜D
%   (2) QRigit JointǉD
%   (3) PInputiu1j̃XC_[Kȑ傫ɐݒ肵CV~[VC
%      XԂŐÎ~D
%   (4) Î~̊֐ߊpq12,q22Ɠu2̒l
%		g1a=(u1-g2a*cos(q12+q22))/cos(q12);
%
%  1.3 Œ肹ɐÎ~iL1.11.2Ɣrj
%   (1) QRigit Joint폜D
%   (2) QInput̃XC_[L1.11.2ŎgplŁCV~[VC
%      XԂŐÎ~D
%   (3) Î~̊֐ߊpq13,q23Ɠu1,u2̒l
%		g2b=u2/cos(q13+q23);
%		g1b=(u1-u2)/cos(q13);
%
%  1.4 d͍̓茋ʂ̌
%   ꂽg1ag2a邢g1bg2bpďd͕⏞sCʂD
%   (1) PNCQNƂɂi֐ߊpq1=q2=0j
%   (2) Input̃XC_[u1g1a+g2a̒lCu2g2a̒lɐݒ肵CV~[VC
%      NÎ~Ă邱ƂmFDlg1bg2bpĊmFD
%   (3) L(2)̑ɁCȉ̂悤MATLABœ͂vZāCV~[VC
%      mFĂ悢D
%     (3.1) Application InterfacêQInput (u1u2)ConnectɂD
%     (3.2) Application Interface"Execute"̂悤ɐݒ肷D
%         x=[x1;x2;x3;x4];[u1,u2]=scara2_gcmp(x,g1a,g2a);
%     (3.3) [Run]ŃV~[VsDlg1bg2bpĊmFD
%
%  2. F^sDiwm_scidens2.m QƁj

g2a=u2/cos(q11+q21);
g1a=(u1-g2a*cos(q12+q22))/cos(q12);

g2b=u2/cos(q13+q23);
g1b=(u1-u2)/cos(q13);
