function prm_est = wm_scidens2(g1,g2,filename1,filename2,filename3)

% Working Model 2Dō쐬2DOF SCARA Robot̓i肻2j
%   prm_est   : [M12; m11; m22; D1; D2; g1; g2] ̐l
%   g1, g2    : Î~œꂽp[^g1g2̐l
%   filemname1: PŒ肵Working Model 2D̏o͂f[^t@C
%   filemname2: Q0ŌŒ肵Working Model 2D̏o͂f[^t@C
%   filemname3: Q90ŌŒ肵Working Model 2D̏o͂f[^t@C
%   ijq, q', q"͑
%
%-----------------------------------------------------------
%
% 0. `1. FÎ~sCwm_scidens1.m ŏd͂Ɋւp[^
%  g1,g2𐄒肵ĂD
%
% 2. F^
%  2.1 PŒ肵āCQ̂݉^D
%   (1) Application Interface Input u1DisconnectɁCu2ConnectɂD
%   (2) PNAnchorłD
%   (3) Application Interface"Execute"ŁCd͕⏞ŁC
%      U^悤ɐݒ肷DigƐU͓Kɐݒ肷j
%      ijx=[x1;x2;x3;x4];[ug1,ug2]=scara2_gcmp(x,g1b,g2b);u1=ug1+0.3*sin(t);u2=ug2+0.1*sin(1.3*t);
%   (4) [Run]ŃV~[VsD
%   (5) [File]j[[Export]R}hŁCKȃt@Cifilename1jɏo͂D
%      ̂ƂOptionevery meterŁCInclude headerɃ`FbNĂD
%      o̗͂LȂ̂ŁCKvȂΌWđ傫ȒlƂƂ悢D
%   (6) o͂ꂽt@C̏ォ4sڂ̃wb_[𒲂ׂăf[^̏ԂmFD
%      ȉC̏Ƀf[^ۑĂꍇɂƂD
%          t@q1@q2@q1'@q2'@frame@t@t@q1"@q2"@u1@u2
%   (7) KȃGfB^ŏo͂ꂽt@C̏4s폜邩C邢
%      [Export]R}hOptionInclude header̃`FbNOāCo͂D
%
%  2.2 Q0ŌŒ肵āCP̂݉^D
%   (1) Application Interface Input u1DisconnectɁCu2ConnectɂD
%   (2) PNAnchor폜CQ܂L΂ԁiq2=0jŁC
%      Rigit JointǉČŒ肷D
%   (3) L2.1(3)`(7)ƓlɂāCV~[VsC
%      Kȃt@Cifilename2jɏo͂D
%
%  2.3 Q90ŌŒ肵āCP̂݉^D
%   (1) Application Interface Input u1DisconnectɁCu2ConnectɂD
%   (2) Q90ɋȂԁiq2=pi/2jłQŒ肷D
%   (3) L2.1(3)`(7)ƓlɂāCV~[VsC
%      Kȃt@Cifilename3jɏo͂D
%
%  2.4 Mt@CCCsƁCprm_estɐlvZD

%     TvO̖Ȃ̂CłȂD
%     ȉ̌vZł́Cd͕⏞vZčĂ邪CvZ
%     Working Model 2Dug1,ug2ۑ悤ɂ悢D
%     ň̏ꍇCWorking Model 2D[World]j[[Gravity]"None"ɂC
%     Application Interface"Execute"̂悤ɂĂ݂D
%       u1=0.3*sin(t);u2=0.1*sin(1.3*t);
%     ̏ꍇɂ́Cgsw=1gsw=0ɕύXD
gsw=1;

%  t, q1, q2, q1', q2', q1", q2" ̗̔ԍ̃f[^̏ɕύX
No_t  =1;	% t
No_q1 =2;	% q1
No_q2 =3;	% q2
No_q1v=4;	% q1'
No_q2v=5;	% q2'
No_q1a=9;	% q1"
No_q2a=10;	% q2"
No_u1 =11;	% u1
No_u2 =12;	% u2

wm=load(filename1);
A=[wm(:,No_q2a) wm(:,No_q2v)];
if gsw ~= 0
	for lp=1:size(wm,1)
		x=[wm(lp,No_q1);wm(lp,No_q2);wm(lp,No_q1v);wm(lp,No_q2v)];
		[ug1,ug2]=scara2_gcmp(x,g1,g2);
		ud(lp,1)=wm(lp,No_u2)-ug2;
	end
else
	ud=wm(:,No_u2);
end
prm2=A\ud;					% [m22 D2]

wm=load(filename2);
A=[wm(:,No_q1a) wm(:,No_q1v)];
if gsw ~= 0
	clear ud;
	for lp=1:size(wm,1)
		x=[wm(lp,No_q1);wm(lp,No_q2);wm(lp,No_q1v);wm(lp,No_q2v)];
		[ug1,ug2]=scara2_gcmp(x,g1,g2);
		ud(lp,1)=wm(lp,No_u1)-ug1;
	end
else
	ud=wm(:,No_u1);
end
prm10=A\ud;					% [2M12+m11 D1]

wm=load(filename3);
A=[wm(:,No_q1a) wm(:,No_q1v)];
if gsw ~= 0
	clear ud;
	for lp=1:size(wm,1)
		x=[wm(lp,No_q1);wm(lp,No_q2);wm(lp,No_q1v);wm(lp,No_q2v)];
		[ug1,ug2]=scara2_gcmp(x,g1,g2);
		ud(lp,1)=wm(lp,No_u1)-ug1;
	end
else
	ud=wm(:,No_u1);
end
prm11=A\ud;					% [m11 D1]

% ɂp[^̐l
M12=(prm10(1)-prm11(1))/2;
m11=prm11(1);
m22=prm2(1);
D1=(prm10(2)+prm11(2))/2;
D2=prm2(2);
prm_est=[M12;m11;m22;D1;D2;g1;g2];
