function prm_est = wm_scident(filename)

% Working Model 2Dō쐬2DOF SCARA Robot̓ij
%   prm_est  : [M12; m11; m22; D1; D2; g1; g2] ̐l
%   filemname: Working Model 2D̏o͂f[^t@C
%   ijq, q', q"͑
%
%-----------------------------------------------------------
%
% 0. 
%   (1) Working Model 2DŊpxƓ͂ł悤ɁCMeasureǉD
%   (2) MeasurePropertiesLabelEquationォ珇Ɏ̂悤ɐݒ肷D
%        () Label  Equation
%              t     time
%              a1    Body[1].a.r
%              a2    Body[2].a.r-Body[1].a.r
%              u1    Input[12]
%              u2    Input[16]
%        CLabel͔Cӂ̖Oł悢C
%                BodyInput̔ԍ͎̃fɍ킹邱ƁD
%
% 1. d͕⏞̊Ťς
%  (1) Application InterfacêQInput (u1u2)DisconnectɂD
%  (2) QInput̃XC_[Kȑ傫ɐݒ肵CV~[VC
%      XԂŐÎ~悤Input̒lD
%
% 2. 
%  (1) Application Interface ̂QInput (u1u2)Connectɖ߂D
%  (2) LPŋ߂Input̒lApplication Interface"Initialize"
%      ϐu01u02Őݒ肷D
%      iju01=50; u02=10;
%  (3) Application Interface"Execute"u1u2L̒l𒆐SƂ
%      U^悤ɐݒ肷DiUgȂǂ͓Kɐݒ肷j
%      iju1=u01+0.1*sin(t); u2=u02+0.1*sin(1.3*t);
%      iju = u0 .* (1+0.8*(myrand(floor(t/0.05)*2)-0.5)); u1=u(1); u2=u(2);
%  (4) [World]j[[Pause Control]߂ɐݒ肷D
%      CUɂȂȂق悢D
%       () time > 50
%  (5) [Run]ŃV~[VsD
%  (6) [File]j[[Export]R}hŁCKȃt@Cɏo͂D
%      ̂ƂOptionevery meterŁCInclude headerɃ`FbNĂD
%      o̗͂LȂ̂ŁC[View]j[[Numbers and Units]Ō𑝂₵ĂD
%  (7) o͂ꂽt@C̏ォ4sڂ̃wb_[𒲂ׂăf[^̏ԂmFD
%      ȉC̏Ƀf[^ۑĂꍇɂƂD
%          t@q1@q2@q1'@q2'@frame@t@t@q1"@q2"@u1@u2
%  (8) KȃGfB^ŏo͂ꂽt@C̏4s폜邩C邢
%      [Export]R}hOptionInclude header̃`FbNOāCo͂D
%  (9) Mt@CCCsƁCprm_estɐlvZD

%  Working Model 2Dŏo͂ꂽt@Cload
wm=load(filename);
%
%  q  [q1 q2 q1' q2' q1" q2"] ƂȂ悤Ɏ̃f[^̏ɕύX
q=[wm(:,2) wm(:,3) wm(:,4) wm(:,5) wm(:,9) wm(:,10)];
%  y  [u1; u2] ƂȂ悤Ɏ̃f[^̏ɕύX
y=[wm(:,11);wm(:,12)];
%
zz=zeros(size(q,1),1);
c2=cos(q(:,2));s2=sin(q(:,2));c12=cos(q(:,1)+q(:,2));
%
a11=c2.*(2*q(:,5)+q(:,6))-s2.*(2*q(:,3).*q(:,4)+q(:,4).*q(:,4));
a21=c2.*q(:,5)+s2.*q(:,3).*q(:,3);
A=[a11 q(:,5)  q(:,6)         q(:,3)  zz     cos(q(:,1)) c12
   a21 zz     (q(:,5)+q(:,6)) zz      q(:,4) zz          c12];
%
prm_est=A\y;			% inv(A'*A)*A'*y
